Gecode::Int::NoOverlap::OptBox< Dim, n > Class Template Reference

Optional box class. More...

`#include <no-overlap.hh>`

## Public Member Functions

void | optional (BoolView o)
| Set Boolean view to o.
bool | mandatory (void) const
| Whether box is mandatory.
bool | optional (void) const
| Whether box is optional.
bool | excluded (void) const
| Whether box is excluded.
ExecStatus | exclude (Space &home)
| Exclude box.
void | update (Space &home, OptBox< Dim, n > &r)
| Update box during cloning.
void | subscribe (Space &home, Propagator &p)
| Subscribe propagator p to box.
void | cancel (Space &home, Propagator &p)
| Cancel propagator p from box.
void | reschedule (Space &home, Propagator &p)
| Schedule propagator p.
Public Member Functions inherited from Gecode::Int::NoOverlap::ManBox< Dim, n >
const Dim & | operator[] (int i) const
| Access to dimension i.
Dim & | operator[] (int i)
| Access to dimension i.
bool | mandatory (void) const
| Whether box is mandatory.
bool | optional (void) const
| Whether box is optional.
bool | excluded (void) const
| Whether box is excluded.
ExecStatus | exclude (Space &home)
| Exclude box.
bool | nooverlap (const ManBox< Dim, n > &b) const
| Check whether this box does not any longer overlap with b.
bool | overlap (const ManBox< Dim, n > &b) const
| Check whether this box overlaps with b.
ExecStatus | nooverlap (Space &home, ManBox< Dim, n > &b)
| Propagate that this box does not overlap with b.
void | update (Space &home, ManBox< Dim, n > &r)
| Update box during cloning.
void | subscribe (Space &home, Propagator &p)
| Subscribe propagator p to box.
void | cancel (Space &home, Propagator &p)
| Cancel propagator p from box.
void | reschedule (Space &home, Propagator &p)
| Schedule propagator p.

## Protected Attributes

BoolView | o
| Whether box is optional or not.
Protected Attributes inherited from Gecode::Int::NoOverlap::ManBox< Dim, n >
Dim | d [n]
| Dimensions.

## Additional Inherited Members

Static Public Member Functions inherited from Gecode::Int::NoOverlap::ManBox< Dim, n >
static int | dim (void)
| Return number of dimensions.

## Detailed Description

template<class Dim, int n>
class Gecode::Int::NoOverlap::OptBox< Dim, n >

Optional box class.

Definition at line 191 of file no-overlap.hh.

## Member Function Documentation

## optional() [1/2]

template<class Dim, int n>

void Gecode::Int::NoOverlap::OptBox< Dim, n >::optional | ( | BoolView | o | ) |

inline

Set Boolean view to o.

Definition at line 151 of file box.hpp.

## mandatory()

template<class Dim, int n>

bool Gecode::Int::NoOverlap::OptBox< Dim, n >::mandatory | ( | void |  | ) | const

inline

Whether box is mandatory.

Definition at line 156 of file box.hpp.

## optional() [2/2]

template<class Dim, int n>

bool Gecode::Int::NoOverlap::OptBox< Dim, n >::optional | ( | void |  | ) | const

inline

Whether box is optional.

Definition at line 166 of file box.hpp.

## excluded()

template<class Dim, int n>

bool Gecode::Int::NoOverlap::OptBox< Dim, n >::excluded | ( | void |  | ) | const

inline

Whether box is excluded.

Definition at line 161 of file box.hpp.

## exclude()

template<class Dim, int n>

ExecStatus Gecode::Int::NoOverlap::OptBox< Dim, n >::exclude | ( | Space & | home | ) |

inline

Exclude box.

Definition at line 172 of file box.hpp.

## update()

template<class Dim, int n>

void Gecode::Int::NoOverlap::OptBox< Dim, n >::update | ( | Space & | home,
|  | OptBox< Dim, n > & | r )

inline

Update box during cloning.

Definition at line 179 of file box.hpp.

## subscribe()

template<class Dim, int n>

void Gecode::Int::NoOverlap::OptBox< Dim, n >::subscribe | ( | Space & | home,
|  | Propagator & | p )

inline

Subscribe propagator p to box.

Definition at line 186 of file box.hpp.

## cancel()

template<class Dim, int n>

void Gecode::Int::NoOverlap::OptBox< Dim, n >::cancel | ( | Space & | home,
|  | Propagator & | p )

inline

Cancel propagator p from box.

Definition at line 192 of file box.hpp.

## reschedule()

template<class Dim, int n>

void Gecode::Int::NoOverlap::OptBox< Dim, n >::reschedule | ( | Space & | home,
|  | Propagator & | p )

inline

Schedule propagator p.

Definition at line 198 of file box.hpp.

## Member Data Documentation

## o

template<class Dim, int n>

BoolView Gecode::Int::NoOverlap::OptBox< Dim, n >::o

protected

Whether box is optional or not.

Definition at line 195 of file no-overlap.hh.

The documentation for this class was generated from the following files:

- gecode/int/no-overlap.hh
- gecode/int/no-overlap/box.hpp